#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>

struct Customer {
    int id;
    std::string tcKimlik;
    std::string ad;
    std::string soyad;
    std::string dogumTarihi;
    std::string telefon;
};

int nextId = 1;

void dosyaOlustur() {
    std::ifstream file("musteriler.txt");
    if (!file.is_open()) {
        std::ofstream newFile("musteriler.txt");
        if (!newFile.is_open()) {
            std::cerr << "Dosya oluşturulamadı." << std::endl;
        } else {
            newFile.close();
        }
    }
    file.close();
}

void kayitEkle(std::vector<Customer>& customers) {
    Customer yeniMusteri;
    yeniMusteri.id = nextId++;

    std::cout << "TC Kimlik: ";
    std::getline(std::cin, yeniMusteri.tcKimlik);

    std::cout << "Ad: ";
    std::getline(std::cin, yeniMusteri.ad);

    std::cout << "Soyad: ";
    std::getline(std::cin, yeniMusteri.soyad);

    std::cout << "Doğum Tarihi: ";
    std::getline(std::cin, yeniMusteri.dogumTarihi);

    std::cout << "Telefon: ";
    std::getline(std::cin, yeniMusteri.telefon);

    customers.push_back(yeniMusteri);
    std::cout << "Müşteri başarıyla kaydedildi. Müşteri ID: " << yeniMusteri.id << std::endl;

    // Müşteriyi dosyaya kaydet
    std::ofstream file("musteriler.txt", std::ios_base::app);
    if (file.is_open()) {
        file << yeniMusteri.id << "," << yeniMusteri.tcKimlik << "," << yeniMusteri.ad << ","
             << yeniMusteri.soyad << "," << yeniMusteri.dogumTarihi << "," << yeniMusteri.telefon << "\n";
        file.close();
    } else {
        std::cerr << "Dosya açılamadı." << std::endl;
    }
}

void musteriSil(std::vector<Customer>& customers) {
    if (customers.empty()) {
        std::cout << "Silinecek müşteri bulunmamaktadır." << std::endl;
        return;
    }

    int id;
    std::cout << "Silinecek müşterinin ID'sini girin: ";
    std::cin >> id;

    auto it = std::find_if(customers.begin(), customers.end(), [id](const Customer& c) { return c.id == id; });
    if (it != customers.end()) {
        customers.erase(it);
        std::cout << "Müşteri başarıyla silindi." << std::endl;
    } else {
        std::cout << "ID'si " << id << " olan bir müşteri bulunamadı." << std::endl;
    }
}

void musteriBilgileriniGoruntule(const std::vector<Customer>& customers) {
    if (customers.empty()) {
        std::cout << "Kayıtlı müşteri bulunmamaktadır." << std::endl;
        return;
    }

    std::cout << "Kayıtlı Müşteriler:" << std::endl;
    for (const auto& musteri : customers) {
        std::cout << "ID: " << musteri.id << std::endl;
        std::cout << "TC Kimlik: " << musteri.tcKimlik << std::endl;
        std::cout << "Ad: " << musteri.ad << std::endl;
        std::cout << "Soyad: " << musteri.soyad << std::endl;
        std::cout << "Doğum Tarihi: " << musteri.dogumTarihi << std::endl;
        std::cout << "Telefon: " << musteri.telefon << std::endl;
        std::cout << std::endl;
    }
}

int main() {
    // Dosyayı oluştur
    dosyaOlustur();

    // Müşteri bilgilerini tutmak için bir vektör oluştur
    std::vector<Customer> customers;

    // Müşterileri dosyadan oku
    std::ifstream file("musteriler.txt");
    if (file.is_open()) {
        std::string line;
        while (std::getline(file, line)) {
            std::istringstream iss(line);
            Customer musteri;
            std::string id;
            std::getline(iss, id, ',');
            musteri.id = std::stoi(id);
            std::getline(iss, musteri.tcKimlik, ',');
            std::getline(iss, musteri.ad, ',');
            std::getline(iss, musteri.soyad, ',');
            std::getline(iss, musteri.dogumTarihi, ',');
            std::getline(iss, musteri.telefon, ',');
            customers.push_back(musteri);
        }
        file.close();
    } else {
        std::cerr << "Dosya açılamadı." << std::endl;
    }

    int secim;
    do {
        std::cout << "1. Müşteri Ekle" << std::endl;
        std::cout << "2. Müşteri Sil" << std::endl;
        std::cout << "3. Müşteri Görüntüle" << std::endl;
        std::cout << "4. Çıkış" << std::endl;
        std::cout << "Seçiminizi yapın: ";
        std::cin >> secim;
        std::cin.ignore(); // newline karakterini temizle

        switch (secim) {
            case 1:
                kayitEkle(customers);
                break;
            case 2:
                musteriSil(customers);
                break;
            case 3:
                musteriBilgileriniGoruntule(customers);
                break;
            case 4:
                std::cout << "Programdan çıkılıyor..." << std::endl;
                break;
            default:
                std::cout << "Geçersiz seçim. Tekrar deneyin." << std::endl;
        }
    } while (secim != 4);

    return 0;
}
